/*
 * ItemEmitter.java  $Revision: 1.4 $  $Date: 2007/10/03 04:59:32 $
 *
 * Copyright (C) 2007 Meldcraft Corporation
 *
 * This file is part of Scaffold.
 * 
 * Scaffold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scaffold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Scaffold.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.meldcraft.application.guis.mvc;

import java.awt.Component;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.lang.reflect.InvocationTargetException;

import com.meldcraft.application.ApplicationContext;
import com.meldcraft.util.ReflectUtil;

/**
 * @version $Revision: 1.4 $ $Date: 2007/10/03 04:59:32 $
 * @author Rob Richards
 */
public class ItemEmitter implements ItemListener
{
    private ApplicationContext  mContext;
    private String              mElementId;

    public ItemEmitter(ApplicationContext context, String elementId, Component comp)
    {
        mContext = context;
        mElementId = elementId;

        try
        {
            ReflectUtil.invokeMethod(comp, "addItemListener", this);
        }
        catch (NoSuchMethodException e)
        {
            throw new RuntimeException("Could not addItemListener", e);
        }
        catch (IllegalAccessException e)
        {
            throw new RuntimeException("Could not addItemListener", e);
        }
        catch (InvocationTargetException e)
        {
            throw new RuntimeException("Could not addItemListener", e);
        }
    }

    public void itemStateChanged(ItemEvent e)
    {
        if (e.getStateChange() == ItemEvent.SELECTED)
        {
            mContext.contextChanged(mElementId + ".selectValue", e.getItem());
        }
    }
}



